program RFM12_Master;

{$NOSHADOW}
{ $WG}                     {global Warnings off}

Device = mega8, VCC=5;
{ $BOOTRST $00C00}         {Reset Jump to $00C00}

Import SysTick, RTclock, SerPort;

From System Import RTCTimer;

Define
  ProcClock      = 12000000;       {Hertz}
  SysTick        = 10;             {msec}
  StackSize      = $0032, iData;
  FrameSize      = $0032, iData;
  SerPort        = 9600, Stop2;    {Baud, StopBits|Parity}
  RxBuffer       = 8, iData;
  TxBuffer       = 8, iData;
  RTClock        = iData, DateTime;    {Time, DateTime}
  RTCsource      = SysTick;

Define_Usr
  defSnap_S_Address = $FF;
  defSnap_T_Address = $01;

Implementation

{$IDATA}
{$I C:\E-lab\_Include\SnapProt.pas}
{$I C:\E-lab\_Include\MySPI.pas}

{--------------------------------------------------------------}
{ Type Declarations }
type

{--------------------------------------------------------------}
{ Const Declarations }

{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}
Var
  i : Byte;

{--------------------------------------------------------------}
{ functions }

Procedure RTCtimer;
begin
  RFM_WaitRx := False;
end;

procedure InitPorts;
begin
  DDRD:=  %01000000;
  Init_SPI_Ports;
end InitPorts;


{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
  InitPorts;

  EnableInts;

  RTCtimer_Load(2);

  Init_FRM12;

  Set_RxMode(rx_polling, dt_ByteMode);

  writeln(SerOut, 'Master');

  i := 0;

  loop
    //
    // Daten senden:
    //
    RFM_CharPacket[0] := 'M';
    RFM_BytePacket[1] := i;

    Tx_On;
    SendPacket;
    Tx_Off;

    ClearBuffer;
    //
    // auf Rckantwort warten:
    //
    Rx_On;

    rtcTimer_Start;

    RFM_Receive_Data;

    If RFM_B_Full Then

      rtcTimer_Stop;

      i := RFM_BytePacket[1];
      write  (SerOut, RFM_CharPacket[0]+': ');
      writeln(SerOut, ByteToStr(i:3:'0'));
      INC(i);
      If i = 255 Then
        i := 0;
      EndIf;
    EndIf;

    ClearBuffer;

    mDelay(1000);

  endloop;
end RFM12_Master.

